import { RefObject, RefCallback } from "react";
declare type ObservedSize = {
    width: number | undefined;
    height: number | undefined;
};
declare type ResizeHandler = (size: ObservedSize) => void;
declare type HookResponse<T extends HTMLElement> = {
    ref: RefObject<T>;
    callbackRef: RefCallback<T>;
} & ObservedSize;
declare function useResizeObserver<T extends HTMLElement>(opts?: {
    onResize?: ResizeHandler;
}): HookResponse<T>;
declare function useResizeObserver<T extends HTMLElement>(opts?: {
    ref: RefObject<T>;
    onResize?: ResizeHandler;
}): HookResponse<T>;
declare function useResizeObserver<T extends HTMLElement>(opts?: {
    ref: RefObject<T> | T | null | undefined;
    onResize?: ResizeHandler;
}): HookResponse<T>;
export default useResizeObserver;
